// things are simple

#ifndef GLOBALES
#define GLOBALES

#define POSTNET_VERSION "1.0"

enum PNETMSG {
	PVERSION = 0, DOWNLOAD, NOT_AVAILABLE, PNET_OK,
	GET, HAVE_REPLY, YOU_HAVE_REPLY,
	POINT_CHANGE_REPLY, VERIFY_R, POINT_CHANGE_PARENT,
	VERIFY_P, REDONE, PING, BAD_MESSAGE
};

extern PNETMSG PMSGtype (char*);

#define ahtoi(x)	strtoul (x, NULL, 16)

#define PFIELD_TITLE	0
#define PFIELD_AUTHOR	1
#define PFIELD_DATE	2
#define PFIELD_CRC	3
#define PFIELD__LAST	4

#define MAX_PRL		100
#define MAX_TITLE	70
#define MAX_AUTHOR	20
#define MAX_DATE	40
#define MAX_CRC		10
#define MAX_MSGID	18
#define MAX_MAX		MAX_PRL + MAX_TITLE + MAX_AUTHOR + MAX_DATE + MAX_CRC

// lets try something else.
// all the global variables of the program gathered here
// could/should be a namespace, but i just hate C++ scopes.

#define Q_MAX_PING	100
#define R_MAX_MODIFIED	100
#define R_MAX_TIME	600

#define POSTNET_HOME	"~/.POSTNET"
#define RECOVERY_FILE	"RECOVERY"
#define BAN_FILE	"Banned"
#define SETTINGS_FILE	".settings"
#define LOCK_FILE	"lock"
#define LOGFILE		"LOGFILE"

extern struct once {

	char *PMSGtext		[BAD_MESSAGE];
	char *PNetFields	[PFIELD__LAST];
	int fieldOverhead;

	bool AmIFirewalled;
	char *ThisAuthor;
	char *ThisPoint;
	char *LOCpass;
	short LocalPort;
	int nClients;

	struct {
		bool DoRaw, DoHttp, FreePort;
		unsigned long int VIP;
	} iOptions;

	short HTTPPort;
	char *HTTPPassword;

	struct {
		char *Text;
		unsigned int size;
	} Greeting;

	unsigned int TopPostID;
	intTree Posts;
	sem_t DatabaseLock;

	unsigned int QueuerSleep;
	dbsTree QueuerTree;
	sem_t QueuerLock;

	dbsNode *PingRequested [Q_MAX_PING];
	char *PingSuccess [Q_MAX_PING];
	unsigned int nPR, nPS;

	struct {
		unsigned int Modified [R_MAX_MODIFIED], c;
		time_t last;
	} RDiff;
	int RecoveryFd;

	dbsTree Banned;

	int loglevel;
	FILE *LOG;

	pid_t MasterPID;
	bool CanReplyToFinger;
	bool Shutdown;

	bool Initialization ();
	void SaveSettings ();

} Globals;

void logprintf (int, const char*, ...);

// dcls
bool	isPRLaddr (char*);
int	slashcount (char*);
int	send_posttext (unsigned int, int);
int	open_postpid (unsigned int, int);
int	rename_ipi (char*, unsigned int);
FILE*	fopen_postpid (unsigned int, char*);
int	posttextsize (unsigned int);
unsigned long postcrc (unsigned int);
bool	contact (char*, i_argstream&, char*, int&);
char*	PRLofMsgID (unsigned int, unsigned int, char*);
char*	CPofPRL (char*, char*);
bool	selfref (char*);
bool	goodPRL (char*);

// inits
void LoadIPI ();
void SaveIPI ();
void QinitDB ();
void myPointChange ();				// postnet -c
void EditIPI (char*);				// postnet -E char*

// Recovery diffs
void RNewRep (unsigned int, partial_post*);
void RDelRep (unsigned int, char*);
void Rposted (unsigned int, cryptotype);
void Rupdate_p (unsigned int, cryptotype);
void Rupdate_r (unsigned int, cryptotype, cryptotype);
void PrepareRecovery ();			// at initialization
void CloseRecovery ();				// termination

// Q
void QStart ();					// forks off queuer
void QAdapt (char*, char*);			// called by server
void QNewReply (char*, unsigned int);		// called by server
void QPing (char*);				// called by user
void QChPoint (char*, unsigned int, cryptotype);// at initialization

// banned :(
bool Banned (char*);				// called by server
void Ban (char*);				// called by user
void LoadBanned ();				// at init
void SaveBanned ();				// at init
void Guru_explict_cp (char*, char*);		// admin
void Guru_pattern_cp (char*, char*);		// admin
bool change_LOC_passwd (char*);			// admin

// server
int do_client (int);				// forks off client handler
void enter_POSTNET ();				// main

// other
post *Submit (char*, char*, char*, int);	// by user
void Admin_Remove_Post (unsigned int, char*);	// by user
void ShutDown ();				// internal termination
#endif
